$IF 0
I developed this program from  Erika Schulze and Gunther Ilzig
Public Domain Big Real Vesa routines.
This Program is Public domain.
$ENDIF

'===========================================================================
'compiler instructions                                                     =
'===========================================================================

$CPU 80386			'compile for 80386 or better CPU
$FLOAT PROCEDURE		'generate FPU instructions

$OPTIMIZE SPEED            	'make a fast code
$COMPILE EXE              	'compile to an EXE

$DEBUG MAP OFF            	'turn off map file generation
$DEBUG PBDEBUG OFF        	'don't include pbdebug support

$LIB COM OFF       		'turn off communications library.
$LIB CGA OFF       		'turn off CGA graphics library.
$LIB EGA OFF       		'turn off EGA graphics library.
$LIB VGA OFF        		'turn off VGA graphics library.

$LIB LPT OFF       		'turn off printer support library.
$LIB IPRINT OFF       		'turn off interpreted print library.

$ERROR BOUNDS OFF       	'turn off bounds checking
$ERROR NUMERIC OFF       	'turn off numeric checking
$ERROR OVERFLOW OFF       	'turn off overflow checking
$ERROR STACK OFF       		'turn off stack checking

$COM 0                 		'set communications buffer to nothing
$STRING 1                	'set largest string size at 32 KByte
$STACK 2048              	'let's use a 2k Stack
$SOUND 1                 	'smallest music buffer possible


'----- define the VBE information block

TYPE VBEInfoBlock
  VbeSignature      AS STRING*4	'VBE Signature
  VbeVersion        AS WORD	'VBE Version
  OemStringPtr      AS DWORD    'Pointer to OEM String
  Capabilities      AS DWORD    'Capabilities of graphics environment
  VideoModePtr      AS DWORD    'Pointer to Video Mode List
  TotalMemory       AS WORD	'Number of 64 KB memory blocks

  				'the next entries are added for VBE 2.0
  OemSoftwareRev    AS WORD	'VBE implementation Software revision
  OemVendorNamePtr  AS DWORD    'Pointer to Vendor Name String
  OemProductNamePtr AS DWORD    'Pointer to Product Name String
  OemProductRevPtr  AS DWORD    'Pointer to Product Revision String
  Reserved          AS STRING*222
  				'Reserved for VBE implementation
  OemData           AS STRING*256
  				'Data Area for OEM Strings
END TYPE


'----- define the Mode Information Block

TYPE ModeInfoBlock
                                'mandatory information for all VBE revisions
  ModeAttributes      AS WORD   'mode attributes
  WinAAttributes      AS BYTE   'window A attributes
  WinBAttributes      AS BYTE   'window B attributes
  WinGranularity      AS WORD   'window granularity
  WinSize             AS WORD   'window size
  WinASegment         AS WORD   'window A start segment
  WinBSegment         AS WORD   'window B start segment
  WinFuncPtr          AS DWORD  'pointer to window function
  BytesPerScanLine    AS WORD   'bytes per scan line

  				'mandatory information for
                                'VBE 1.2 and above
  XResolution         AS WORD	'horizontal resolution in pixels or chars
  YResolution         AS WORD   'vertical resolution in pixels or chars
  XCharSize           AS BYTE   'character cell width in pixels
  YCharSize           AS BYTE   'character cell height in pixels
  NumberOfPlanes      AS BYTE   'number of memory planes
  BitsPerPixel        AS BYTE   'bits per pixel
  NumberOfBanks       AS BYTE   'number of banks
  MemoryModel         AS BYTE   'memory model type
  BankSize            AS BYTE   'bank size in KB
  NumberOfImagePages  AS BYTE   'number of image pages
  Reserved1           AS BYTE   'reserved for page function

  				'Direct Color fields (required for
                                'direct and YUV memory models)
  RedMaskSize         AS BYTE   'size color red mask in bits
  RedFieldPosition    AS BYTE   'lsb bit position of red mask
  GreenMaskSize       AS BYTE   'size color green mask in bits
  GreenFieldPosition  AS BYTE   'lsb bit position of green mask
  BlueMaskSize        AS BYTE   'size color blue mask in bits
  BlueFieldPosition   AS BYTE   'lsb bit position of blue mask
  RsvdMaskSize        AS BYTE   'size color reserved mask in bits
  RsvdFieldPosition   AS BYTE   'lsb bit position of reserved mask
  DirectColorModeInfo AS BYTE   'direct color mode attributes

  				'mandatory information for
                                'VBE 2.0 and above
  PhysBasePtr         AS DWORD  'physical address for flat frame buffer
  OffScreenMemOffset  AS DWORD  'pointer to start of off screen memory
  OffScreenMemSize    AS WORD   'amount of off screen memory in 1KB units
  Reserved2           AS STRING * 256
  				'remainder of ModeInfoBlock
END TYPE

DIM VBE AS SHARED VBEInfoBlock		'dimension of the block

PbvSwitch = 0
VBE.VbeSignature = "VBE2"	'should be the default when the function
				'is called to indicate VBE 2.0
VbePtr32??? = VARPTR32(VBE)
                               '32 bit address VBE information block

DIM MIB AS SHARED ModeInfoBlock	'dimension of the block
MIBPtr32???=VARPTR32(MIB)
				'32 bit address Mode Information Block
mode% = VAL(TRIM$(COMMAND$))    'the VESA mode 103h
                                '640 by 480 pixel and 256 colors
				'it's supported by the most graphics adaptors
                                'please change this for another mode

'---------------------------------------------------------------------------
'variables for the memory management

'---------------------------------------------------------------------------
'Test the function 4F00H: Return VBE Controller Information
'---------------------------------------------------------------------------

IF ISFALSE GetVBE%(VbePtr32???) THEN
   PRINT
   PRINT"  Sorry!"
   PRINT"  Function: Return VBE Controller Information failed."
   END	0			'program ends here
END IF
IF VBE.VbeVersion < &H200 THEN
   PRINT
   PRINT "  Sorry!"
   PRINT "  This demonstration requires VBE 2.0"
   PRINT "  Please install such a driver and reboot your system."
   END 0
END IF

'---------------------------------------------------------------------------
'Test the Function: Return VBE Mode Information                            -
'---------------------------------------------------------------------------

IF ISFALSE GetVesaInfo%(mode%,MIBPtr32???) THEN
   PRINT
   PRINT"  Sorry!"
   PRINT"  Function: Return Mode Information Block failed."
   END	0			'program ends here
END IF
'---------------------------------------------------------------------------
'set the VESA mode                                                         -
'---------------------------------------------------------------------------

VbeSize??? = VBE.TotalMemory * 65536
VbePhysBasePtr??? = MIB.PhysBasePtr

OPEN "VESA.DAT" FOR OUTPUT AS #1
WRITE #1,VbePhysBasePtr???
WRITE #1,VbeSize???
CLOSE #1
END 1

FUNCTION GetVbe%(BYVAl VbeBlock???)
!               push    es
!               push    di
!               les     di,VbeBlock???  ;es:di -> VBE information block
!               mov     ax,&H4f00       ;function: Return VBE information
!               int     &H10            ;transfer to VESA driver
!               cmp     al,&H4f         ;function supported?
!               jne     NoSupport20     ;no: jump
!               or      ah,ah           ;function succesful?
!               jnz     NoSupport20     ;no: jump
!               mov     FUNCTION,1      ;yes: set function result TRUE
Support10:
!               pop     di
!               pop     es
EXIT FUNCTION
NoSupport20:
!               mov     FUNCTION,0      ;yes: set function result TRUE
!               jmp     short Support10 ;return to caller
END FUNCTION

FUNCTION GetVesaInfo%(byval Mode%,byval InfoAddress???)
!               push    es
!               push    cx
!               push    di
!               mov     ax,&H4f01       ;FUNCTION: get mode information
!               mov     cx,Mode%        ;cx = vesa mode number
!               les     di,InfoAddress??? ;es:di -> Mode Information Block
!               int     &H10            ;transfer to vesa driver
!               cmp     al,&H4f         ;function supported?
!               jne     NoSupport30     ;no: jump
!               or      ah,ah           ;function succesful?
!               jnz     NoSupport30     ;no: jump
!               mov     FUNCTION,1      ;yes: set function result TRUE
Support40:
!               pop	di
!               pop     cx
!               pop     es
EXIT FUNCTION
NoSupport30:
!               mov     FUNCTION,0      ;yes: set function result TRUE
!               jmp     short Support40
END FUNCTION

FUNCTION SetVesaMode%(BYVAl Mode%)
print "Vesa MODE = ";Mode%
SLEEP
!               push    ax
!               push    bx
!               Mov     AX,&H4F02
!               mov     bx,Mode%        ;bx = VESA Mode
!               or      bx,&H4000       ;use Linear Frame buffer
!               int     &H10            ;transfer to VESA driver
!               cmp     al,&H4f         ;function supported?
!               jne     NoSupport50     ;no: jump
!               or      ah,ah           ;Mode supported?
!               jnz     NoSupport50     ;no: jump
!               pop     bx
!               pop     ax
FUNCTION = 1
EXIT FUNCTION
NoSupport50:
!               pop     bx
!               pop     ax
FUNCTION = 0
END FUNCTION



